// BackgroundConfigDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dem3d.h"
#include "BackgroundConfigDlg.h"
#include "Dem3dDoc.h"
#include "Dem3dView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// BackgroundConfigDlg dialog


BackgroundConfigDlg::BackgroundConfigDlg(CDem3dView* view,
                                         CWnd* pParent /*=NULL*/)
	: CDialog(BackgroundConfigDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(BackgroundConfigDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

   _view = view;
}


void BackgroundConfigDlg::DoDataExchange(CDataExchange* pDX)
{
   if (pDX->m_bSaveAndValidate == FALSE)
      {
         m_bkgrndColor.setPatchColor(_view->getBackgroundColor());
      }

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(BackgroundConfigDlg)
	DDX_Control(pDX, IDC_BACKGROUND_COLOR, m_bkgrndColor);
	//}}AFX_DATA_MAP

   if (pDX->m_bSaveAndValidate == TRUE)
      {
         sg_RGBA color;
         m_bkgrndColor.getPatchColor(color);
         _view->setBackgroundColor(color);
      }
}


BEGIN_MESSAGE_MAP(BackgroundConfigDlg, CDialog)
	//{{AFX_MSG_MAP(BackgroundConfigDlg)
	ON_BN_CLICKED(ID_APPLY, OnApply)
	ON_BN_CLICKED(IDC_BACKGROUND_B1, OnBackGroundB1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// BackgroundConfigDlg message handlers

void BackgroundConfigDlg::OnApply() 
{
   UpdateData(TRUE);
   _view->startRender();	
}

void BackgroundConfigDlg::OnCancel() 
{
   ShowWindow(SW_HIDE);
}

void BackgroundConfigDlg::OnOK() 
{
   UpdateData(TRUE);
   ShowWindow(SW_HIDE);
   _view->startRender();
}

void BackgroundConfigDlg::OnBackGroundB1() 
{
   CColorDialog clrdlg;	

   if (clrdlg.DoModal() == IDOK)
      {
         COLORREF clr = clrdlg.GetColor();
         m_bkgrndColor.setPatchColor(clr);
         Invalidate();
      }		
}
