// CameraDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dem3d.h"
#include "CameraDlg.h"
#include "Dem3dDoc.h"
#include "Dem3dView.h"

#ifndef INCLUDED_SG_CONTROLLER_HXX
#include "scenegraph/sg_Controller.hxx"
#endif

#ifndef INCLUDED_SG_SCENENODE_HXX
#include "scenegraph/sg_SceneNode.hxx"
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CameraDlg dialog


CameraDlg::CameraDlg(CDem3dView* view,
                     sg_ControlLineController* camController,
                     sg_CameraNode* camera,
                     CWnd* pParent /*=NULL*/)
	: CDialog(CameraDlg::IDD, pParent),
     _view(view),
     _camController(camController),
     _camera(camera)
{
	//{{AFX_DATA_INIT(CameraDlg)
	m_altitude = _T("");
	m_azimuth = _T("");
	m_fov = _T("");
	//}}AFX_DATA_INIT
}


void CameraDlg::DoDataExchange(CDataExchange* pDX)
{
   if (pDX->m_bSaveAndValidate == FALSE)
   {
      if (_camController != 0)
      {
         m_altitude.Format("%4.1f",_camController->getCurrentAltitude());
         m_azimuth.Format("%4.1f",_camController->getGeoAzimuth());
         m_fov.Format("%4.1f",_camera->getFieldOfView());
      }
   }

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CameraDlg)
	DDX_Text(pDX, IDC_ALTITUDE, m_altitude);
	DDX_Text(pDX, IDC_AZIMUTH, m_azimuth);
	DDX_Text(pDX, IDC_FOV, m_fov);
	//}}AFX_DATA_MAP

   if (pDX->m_bSaveAndValidate == TRUE)
   {
      if (_camController != 0)
      {
         // XXX Need range checking on all values.
         _camController->setCurrentAltitude(atof(m_altitude));
         _camController->setGeoAzimuth(atof(m_azimuth));
         _camera->setFieldOfView(atof(m_fov));
      }
   }
}


BEGIN_MESSAGE_MAP(CameraDlg, CDialog)
	//{{AFX_MSG_MAP(CameraDlg)
	ON_BN_CLICKED(ID_APPLY, OnApply)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void
CameraDlg::update()
{
   UpdateData(FALSE);
}

/////////////////////////////////////////////////////////////////////////////
// CameraDlg message handlers

void CameraDlg::OnApply() 
{
   UpdateData(TRUE);
   _view->startRender();
}

void CameraDlg::OnCancel() 
{
   ShowWindow(SW_HIDE);
}

void CameraDlg::OnOK() 
{
   UpdateData(TRUE);
   ShowWindow(SW_HIDE);
   _view->startRender();
}
