// ColorPatch.cpp : implementation file
//

#include "stdafx.h"
#include "dem3d.h"
#include "ColorPatch.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#ifndef INCLUDED_SG_TYPES_HXX
#include "scenegraph/sg_Types.hxx"
#endif

/////////////////////////////////////////////////////////////////////////////
// CColorPatch

CColorPatch::CColorPatch()
{
   _patchBrush = 0;
}

CColorPatch::~CColorPatch()
{
}


BEGIN_MESSAGE_MAP(CColorPatch, CStatic)
	//{{AFX_MSG_MAP(CColorPatch)
	ON_WM_CTLCOLOR_REFLECT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColorPatch message handlers

HBRUSH CColorPatch::CtlColor(CDC* pDC, UINT nCtlColor) 
{
	// TODO: Change any attributes of the DC here
	

   delete _patchBrush;
   _patchBrush = new CBrush;
   _patchBrush->CreateSolidBrush(_patchColor);

	// TODO: Return a non-NULL brush if the parent's handler should not be called
	return static_cast<HBRUSH>(*_patchBrush);

}

void
CColorPatch::setPatchColor(COLORREF patchColor)
{
   _patchColor = patchColor;
}

void
CColorPatch::setPatchColor(sg_RGBA const& patchColor)
{
   unsigned long red =   static_cast<long>(patchColor.red * 255.0);
   unsigned long green = static_cast<long>(patchColor.green * 255.0);
   unsigned long blue =  static_cast<long>(patchColor.blue * 255.0);

   _patchColor = RGB(red,green,blue);
}

void
CColorPatch::getPatchColor(COLORREF& color)
{
   color = _patchColor;
}

void
CColorPatch::getPatchColor(sg_RGBA& color)
{
   color.red =   GetRValue(_patchColor) / 255.0;
   color.green = GetGValue(_patchColor) / 255.0;
   color.blue =  GetBValue(_patchColor) / 255.0;
}   