// DaylightConfigDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dem3d.h"
#include "DaylightConfigDlg.h"
#include "Dem3dDoc.h"
#include "Dem3dView.h"

#ifndef INCLUDED_SG_DEMVERTEXSHADER_HXX
#include "scenegraph/sg_DEMVertexShader.hxx"
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DaylightConfigDlg dialog


DaylightConfigDlg::DaylightConfigDlg(CDem3dView* view,
                                     CWnd* pParent /*=NULL*/)
	: CDialog(DaylightConfigDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(DaylightConfigDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
   _view = view;
   _shader = 0;
}

void
DaylightConfigDlg::setShader(sg_DaylightShader* shader)
{
   _shader = shader;
   UpdateData(FALSE);
   Invalidate();
}

void DaylightConfigDlg::DoDataExchange(CDataExchange* pDX)
{
   if (_shader != 0)
      {
         if (pDX->m_bSaveAndValidate == FALSE)
            {
               // Initialize the color patches from the current shader settings.
               m_surfColor.setPatchColor(_shader->getColor());
            }
      }

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DaylightConfigDlg)
	DDX_Control(pDX, IDC_DAYLIGHT_SURFCOLOR, m_surfColor);
	//}}AFX_DATA_MAP

  if (_shader != 0)
      {
         if (pDX->m_bSaveAndValidate == TRUE)
            {
               sg_RGBA color;
               m_surfColor.getPatchColor(color);
               _shader->setColor(color);
            }
      }
}


BEGIN_MESSAGE_MAP(DaylightConfigDlg, CDialog)
	//{{AFX_MSG_MAP(DaylightConfigDlg)
	ON_BN_CLICKED(ID_APPLY, OnApply)
	ON_BN_CLICKED(IDC_DAYLIGHT_B1, OnDaylightB1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DaylightConfigDlg message handlers

void DaylightConfigDlg::OnApply() 
{
   UpdateData(TRUE);
   _view->startRender();	
}

void DaylightConfigDlg::OnCancel() 
{
   ShowWindow(SW_HIDE);
}

void DaylightConfigDlg::OnOK() 
{
   UpdateData(TRUE);
   ShowWindow(SW_HIDE);
   _view->startRender();
}

void DaylightConfigDlg::OnDaylightB1() 
{
   CColorDialog clrdlg;	

   if (clrdlg.DoModal() == IDOK)
      {
         COLORREF clr = clrdlg.GetColor();
         m_surfColor.setPatchColor(clr);
         Invalidate();
      }		
}
