
#ifndef INCLUDED_DEM3DSTATUS_H
#define INCLUDED_DEM3DSTATUS_H

class CStatusBar;
class CProgressCtrl;

class Dem3dStatus  
{

   public:
	   Dem3dStatus(CStatusBar* statBar);

      // These displays share a pane. The most recently set
      // is the one displayed.
      void setCameraAltAz(double altitude, double azimuth);
      void setLightAltAz(double altitude, double azimuth);
      void setWaterLevel(double elevation);
                     
      void setVertExag(double ve);
      void setResolution(double res);
      void setProgress(double percent);
      void setCoords(double x, double y, double z, bool good = true);
         // Object space coordinates of cursor.
         // If 'good' is true, then the coordinates are meaningful..
         // If 'good' is false, coordinates are meaningless and
         // should not be displayed.

      enum Units {FEET, METERS};
      void setElevationUnits(Units u);
         // Default: Meters

      void resize();
         // Must be called whenever view resizes.

   private:
      CStatusBar* _statBar;
      long _cameraPane;
      long _lightPane;
      long _toolPane;
      long _vertExagPane;
      long _resolutionPane;
      long _progressPane;
      long _coordsPane;
      Units _elevUnits;
      CProgressCtrl* _progressCtrl;
};

#endif  // INCLUDED_DEM3DSTATUS_H

