// DemResDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dem3d.h"
#include "DemResDlg.h"
#include "Dem3dDoc.h"
#include "Dem3dView.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DemResDlg dialog


DemResDlg::DemResDlg(CDem3dView* demView, CWnd* pParent /*=NULL*/)
	: CDialog(DemResDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(DemResDlg)
	//}}AFX_DATA_INIT

   _demView = demView;
}


void DemResDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DemResDlg)
	DDX_Control(pDX, IDC_SLIDER1, m_slider1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DemResDlg, CDialog)
	//{{AFX_MSG_MAP(DemResDlg)
	ON_WM_HSCROLL()
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_DEMRES_25P, OnDemRes25P)
	ON_BN_CLICKED(IDC_DEMRES_50P, OnDemRes50P)
	ON_BN_CLICKED(IDC_DEMRES_75P, OnDemRes75P)
	ON_BN_CLICKED(IDC_DEMRES_100P, OnDemRes100P)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DemResDlg message handlers

void DemResDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
   if (_demView != 0)
      {
         double min = m_slider1.GetRangeMin();
         double max = m_slider1.GetRangeMax();
         double cur = m_slider1.GetPos();
         double res = (cur - min) / (max - min);
         _demView->setResolutionDEM(res);
      }
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

int DemResDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
   	
	return 0;
}

void DemResDlg::OnOK() 
{
   ShowWindow(SW_HIDE);	
}

BOOL DemResDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

   m_slider1.SetRangeMin(0);
   m_slider1.SetRangeMax(100);

   update();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void
DemResDlg::update()
{
   if (_demView != 0)
      {
         double min = m_slider1.GetRangeMin();
         double max = m_slider1.GetRangeMax();
         double curRes = _demView->getResolutionDEM();
         long pos = static_cast<long>(min + ((max - min) * curRes));
         m_slider1.SetPos(pos);
      }
}

void DemResDlg::OnDemRes25P() 
{
   if (_demView != 0)
   {
      _demView->setResolutionDEM(0.25);
      update();
   }
}

void DemResDlg::OnDemRes50P() 
{
   if (_demView != 0)
   {
      _demView->setResolutionDEM(0.50);
      update();
   }	
}

void DemResDlg::OnDemRes75P() 
{
   if (_demView != 0)
   {
      _demView->setResolutionDEM(0.75);
      update();
   }	
}

void DemResDlg::OnDemRes100P() 
{
   if (_demView != 0)
   {
      _demView->setResolutionDEM(1.0);
      update();
   }	
}
