
#include "FrameCounter.hxx"

FrameCounter::FrameCounter(long historySize)
            : _historySize(historySize),
              _nextEntry(0),
              _sum(0)
{
   for (long i = 0; i < _historySize; i++)
      _history.push_back(0);
}

void
FrameCounter::frameCompleted(long time)
{
   _sum = _sum - _history[_nextEntry];
   _history[_nextEntry] = time;
   _sum = _sum + _history[_nextEntry];
   _nextEntry = (_nextEntry + 1) % _historySize;
}

double
FrameCounter::getFramesPerSec()
{
   return 1000.0 / ((_sum * 1.0) / _historySize);
}

