#ifndef INCLUDED_FRAMECOUNTER_HXX
#define INCLUDED_FRAMECOUNTER_HXX

#include <vector>
using namespace std;

class FrameCounter
{
   // Provides a smoothed frame rate value.

   public:
      FrameCounter(long history = 10);
         // Smoothed average, default: last 10 values.

      void frameCompleted(long time);
         // Called after a frame has rendered. 'time' is the time
         // the frame took to render in milliseconds.

      double getFramesPerSec();
         // Returns a smoothed average of the current number of frames per second.

   private:
      vector<long> _history;
      long _historySize;
      long _nextEntry;        // Points to next available in _history.
      long _sum;

};

#endif  // INCLUDED_FRAMECOUNTER_HXX
