// GradientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dem3d.h"
#include "GradientDlg.h"
#include "Dem3dDoc.h"
#include "Dem3dView.h"

#ifndef INCLUDED_SG_DEMVERTEXSHADER_HXX
#include "scenegraph/sg_DEMVertexShader.hxx"
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// GradientDlg dialog


GradientDlg::GradientDlg(CDem3dView* view,
                         CWnd* pParent)
	: CDialog(GradientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(GradientDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

   _view = view;
   _shader = 0;
}

void
GradientDlg::setShader(sg_GradientShader* shader)
{
   _shader = shader;
   UpdateData(FALSE);
   Invalidate();
}

void GradientDlg::DoDataExchange(CDataExchange* pDX)
{
   if (_shader != 0)
      {
         if (pDX->m_bSaveAndValidate == FALSE)
            {
               // Initialize the color patches from the current shader settings.
               m_lowColor.setPatchColor(_shader->getLowColor());
               m_highColor.setPatchColor(_shader->getHighColor());
            }
      }

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(GradientDlg)
	DDX_Control(pDX, IDC_GRADIENT_LOWCLR, m_lowColor);
	DDX_Control(pDX, IDC_GRADIENT_HIGHCLR, m_highColor);
	//}}AFX_DATA_MAP

   if (_shader != 0)
      {
         if (pDX->m_bSaveAndValidate == TRUE)
            {
               sg_RGBA color;
               m_lowColor.getPatchColor(color);
               _shader->setLowColor(color);

               m_highColor.getPatchColor(color);
               _shader->setHighColor(color);
            }
      }
}


BEGIN_MESSAGE_MAP(GradientDlg, CDialog)
	//{{AFX_MSG_MAP(GradientDlg)
	ON_BN_CLICKED(IDC_GRADIENT_B1, OnGradientB1)
	ON_BN_CLICKED(IDC_GRADIENT_B2, OnGradientB2)
	ON_BN_CLICKED(ID_APPLY, OnApply)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// GradientDlg message handlers

void GradientDlg::OnGradientB1() 
{
   CColorDialog clrdlg;	

   if (clrdlg.DoModal() == IDOK)
      {
         COLORREF clr = clrdlg.GetColor();
         m_lowColor.setPatchColor(clr);
         Invalidate();
      }	
}

void GradientDlg::OnGradientB2() 
{
   CColorDialog clrdlg;	

   if (clrdlg.DoModal() == IDOK)
      {
         COLORREF clr = clrdlg.GetColor();
         m_highColor.setPatchColor(clr);
         Invalidate();
      }		
}

void GradientDlg::OnApply() 
{
   UpdateData(TRUE);
   _view->startRender();	
}

void GradientDlg::OnCancel() 
{
   ShowWindow(SW_HIDE);
}

void GradientDlg::OnOK() 
{
   UpdateData(TRUE);
   ShowWindow(SW_HIDE);
   _view->startRender();
}
