// HSVConfigDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dem3d.h"
#include "HSVConfigDlg.h"
#include "Dem3dDoc.h"
#include "Dem3dView.h"

#ifndef INCLUDED_SG_DEMVERTEXSHADER_HXX
#include "scenegraph/sg_DEMVertexShader.hxx"
#endif

#include "mfcutils.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// HSVConfigDlg dialog


HSVConfigDlg::HSVConfigDlg(CDem3dView* view,
                           CWnd* pParent)
	         : CDialog(HSVConfigDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(HSVConfigDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

   _view = view;
   _shader = 0;
}

void
HSVConfigDlg::setShader(sg_HSVShader* shader)
{
   _shader = shader;
   UpdateData(FALSE);
   Invalidate();
}

void HSVConfigDlg::DoDataExchange(CDataExchange* pDX)
{
   if (_shader != 0)
      {
         if (pDX->m_bSaveAndValidate == FALSE)
            {
               // Initialize dialog from current shader settings.
               ::setScaledValue(m_colorShiftSlider, 10.0, 360.0,
                                _shader->getLowColorStart());
               ::setScaledValue(m_saturationSlider, 0.0, 1.0,
                                _shader->getSaturation());
               ::setScaledValue(m_valueSlider, 0.0, 1.0,
                                _shader->getValue());
               ::setScaledValue(m_rangeSlider, 10.0, 360.0,
                                _shader->getRange());

               m_hsvIndicator.setLowColorStart(_shader->getLowColorStart());
               m_hsvIndicator.setSaturation(_shader->getSaturation());
               m_hsvIndicator.setValue(_shader->getValue());
               m_hsvIndicator.setRange(_shader->getRange());
            }
      }

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(HSVConfigDlg)
	DDX_Control(pDX, IDC_HSVDLG_RANGESLD, m_rangeSlider);
	DDX_Control(pDX, IDC_HSVDLG_VALUESLD, m_valueSlider);
	DDX_Control(pDX, IDC_HSVDLG_SHFTSLD, m_colorShiftSlider);
	DDX_Control(pDX, IDC_HSVDLG_SATSLD, m_saturationSlider);
	DDX_Control(pDX, IDC_HSVDLG_INDICATOR, m_hsvIndicator);
	//}}AFX_DATA_MAP

   if (_shader != 0)
      {
         if (pDX->m_bSaveAndValidate == TRUE)
            {
               // Update shader settings from dialog.
               _shader->setLowColorStart(::getScaledValue(m_colorShiftSlider, 0.0, 360.0));
               _shader->setSaturation(::getScaledValue(m_saturationSlider, 0.0, 1.0));
               _shader->setValue(::getScaledValue(m_valueSlider, 0.0, 1.0));
               _shader->setRange(::getScaledValue(m_rangeSlider, 10.0, 360.0));
            }
      }
}


BEGIN_MESSAGE_MAP(HSVConfigDlg, CDialog)
	//{{AFX_MSG_MAP(HSVConfigDlg)
	ON_BN_CLICKED(ID_APPLY, OnApply)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// HSVConfigDlg message handlers

void HSVConfigDlg::OnApply() 
{
   UpdateData(TRUE);
   _view->startRender();	
}

void HSVConfigDlg::OnCancel() 
{
   ShowWindow(SW_HIDE);
}

void HSVConfigDlg::OnOK() 
{
   UpdateData(TRUE);
   ShowWindow(SW_HIDE);
   _view->startRender();
}

BOOL HSVConfigDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void HSVConfigDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{

   // XXX Aaaaaaaarg. I have no way of knowing _which_ slider was moved.
   // XXX So, we'll do all three.

   double scaledValue;
   scaledValue = ::getScaledValue(m_colorShiftSlider, 0.0, 360.0);
   m_hsvIndicator.setLowColorStart(scaledValue);

   scaledValue = ::getScaledValue(m_saturationSlider, 0.0, 1.0);
   m_hsvIndicator.setSaturation(scaledValue);

   scaledValue = ::getScaledValue(m_valueSlider, 0.0, 1.0);
   m_hsvIndicator.setValue(scaledValue);

   scaledValue = ::getScaledValue(m_rangeSlider, 10.0, 360.0);
   m_hsvIndicator.setRange(scaledValue);

   m_hsvIndicator.Invalidate();
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
