// LightDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dem3d.h"
#include "Dem3dDoc.h"
#include "Dem3dView.h"
#include "LightDlg.h"

#ifndef INCLUDED_SG_CONTROLLER_HXX
#include "scenegraph/sg_Controller.hxx"
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// LightDlg dialog


LightDlg::LightDlg(CDem3dView* view,
                   sg_AltAzLightController* altAzController,
                   CWnd* pParent /*=NULL*/)
	: CDialog(LightDlg::IDD, pParent),
     _view(view),
     _altAzController(altAzController)
{
	//{{AFX_DATA_INIT(LightDlg)
	m_iconVisible = FALSE;
	m_altitude = _T("");
	m_azimuth = _T("");
	//}}AFX_DATA_INIT
}

void
LightDlg::update()
{
   UpdateData(FALSE);
}

void LightDlg::DoDataExchange(CDataExchange* pDX)
{
   if (pDX->m_bSaveAndValidate == FALSE)
   {
      if (_altAzController != 0)
      {
         m_altitude.Format("%4.1f",_altAzController->getCurrentAltitude());
         m_azimuth.Format("%4.1f",_altAzController->getGeoAzimuth());
         if (_view->lightIconAlwaysOn())
            m_iconVisible = TRUE;
         else
            m_iconVisible = FALSE;
      }
   }

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(LightDlg)
	DDX_Check(pDX, IDC_CHECK1, m_iconVisible);
	DDX_Text(pDX, IDC_ALTITUDE, m_altitude);
	DDX_Text(pDX, IDC_AZIMUTH, m_azimuth);
	//}}AFX_DATA_MAP

   if (pDX->m_bSaveAndValidate == TRUE)
   {
      if (_altAzController != 0)
      {
         double alt,az;
         alt = atof(m_altitude);
         az = atof(m_azimuth);
         _altAzController->setCurrentAltitude(alt);
         _altAzController->setGeoAzimuth(az);
         if (m_iconVisible == TRUE)
            _view->setLightIconAlwaysOn(true);
         else
            _view->setLightIconAlwaysOn(false);
      }
   }
}


BEGIN_MESSAGE_MAP(LightDlg, CDialog)
	//{{AFX_MSG_MAP(LightDlg)
	ON_BN_CLICKED(ID_APPLY, OnApply)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// LightDlg message handlers

void LightDlg::OnApply() 
{
   UpdateData(TRUE);
   _view->startRender();
}

void LightDlg::OnOK() 
{
   UpdateData(TRUE);
   ShowWindow(SW_HIDE);
   _view->startRender();
}

void LightDlg::OnCancel() 
{
   ShowWindow(SW_HIDE);
}
