// SlopeConfigDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dem3d.h"
#include "SlopeConfigDlg.h"
#include "Dem3dDoc.h"
#include "Dem3dView.h"

#ifndef INCLUDED_SG_DEMVERTEXSHADER_HXX
#include "scenegraph/sg_DEMVertexShader.hxx"
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// SlopeConfigDlg dialog


SlopeConfigDlg::SlopeConfigDlg(CDem3dView* view,
                               CWnd* pParent /*=NULL*/)
	: CDialog(SlopeConfigDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(SlopeConfigDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

   _view = view;
   _shader = 0;
}

void
SlopeConfigDlg::setShader(sg_SlopeShader* shader)
{
   _shader = shader;
   UpdateData(FALSE);
   Invalidate();
}

void SlopeConfigDlg::DoDataExchange(CDataExchange* pDX)
{
   if (_shader != 0)
      {
         if (pDX->m_bSaveAndValidate == FALSE)
            {
               // Initialize the color patches from the current shader settings.
               m_flatColor.setPatchColor(_shader->getFlatColor());
               m_steepColor.setPatchColor(_shader->getSteepColor());
            }
      }

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(SlopeConfigDlg)
	DDX_Control(pDX, IDC_SLOPE_STEEPCLR, m_steepColor);
	DDX_Control(pDX, IDC_SLOPE_FLATCLR, m_flatColor);
	//}}AFX_DATA_MAP

  if (_shader != 0)
      {
         if (pDX->m_bSaveAndValidate == TRUE)
            {
               sg_RGBA color;
               m_flatColor.getPatchColor(color);
               _shader->setFlatColor(color);

               m_steepColor.getPatchColor(color);
               _shader->setSteepColor(color);
            }
      }
}


BEGIN_MESSAGE_MAP(SlopeConfigDlg, CDialog)
	//{{AFX_MSG_MAP(SlopeConfigDlg)
	ON_BN_CLICKED(ID_APPLY, OnApply)
	ON_BN_CLICKED(IDC_SLOPE_B1, OnSlopeB1)
	ON_BN_CLICKED(IDC_SLOPE_B2, OnSlopeB2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// SlopeConfigDlg message handlers

void SlopeConfigDlg::OnApply() 
{
   UpdateData(TRUE);
   _view->startRender();	
}

void SlopeConfigDlg::OnSlopeB1() 
{
   CColorDialog clrdlg;	

   if (clrdlg.DoModal() == IDOK)
      {
         COLORREF clr = clrdlg.GetColor();
         m_flatColor.setPatchColor(clr);
         Invalidate();
      }		   	
}

void SlopeConfigDlg::OnSlopeB2() 
{
   CColorDialog clrdlg;	

   if (clrdlg.DoModal() == IDOK)
      {
         COLORREF clr = clrdlg.GetColor();
         m_steepColor.setPatchColor(clr);
         Invalidate();
      }			
}

void SlopeConfigDlg::OnCancel() 
{
   ShowWindow(SW_HIDE);	
}

void SlopeConfigDlg::OnOK() 
{
   UpdateData(TRUE);
   ShowWindow(SW_HIDE);
   _view->startRender();
}
