// VertExagDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dem3d.h"
#include "Dem3dDoc.h"
#include "Dem3dView.h"
#include "VertExagDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// VertExagDlg dialog


VertExagDlg::VertExagDlg(CDem3dView* view, CWnd* pParent /*=NULL*/)
	: CDialog(VertExagDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(VertExagDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

   _demView = view;
   _veMin = -10;
   _veMax = 10;
}


void VertExagDlg::DoDataExchange(CDataExchange* pDX)
{


	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(VertExagDlg)
	DDX_Control(pDX, IDC_SLIDER1, m_slider1);
	//}}AFX_DATA_MAP

   if (pDX->m_bSaveAndValidate == FALSE)
      {
         update();
      }
}


void
VertExagDlg::update()
{
   if (_demView != 0)
      {
         double min = m_slider1.GetRangeMin();
         double max = m_slider1.GetRangeMax();
         double curVE = _demView->getVertExag();
         double tmp = (curVE - _veMin) / (_veMax - _veMin);
         tmp = 1.0 - tmp;
         long pos = static_cast<long>(min + ((max - min) * tmp));
         m_slider1.SetPos(pos);
      }
}

BEGIN_MESSAGE_MAP(VertExagDlg, CDialog)
	//{{AFX_MSG_MAP(VertExagDlg)
	ON_WM_HSCROLL()
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_WM_VSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// VertExagDlg message handlers

void VertExagDlg::OnOK() 
{
   ShowWindow(SW_HIDE);	
}

void VertExagDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
   if (_demView != 0)
      {
         double min = m_slider1.GetRangeMin();
         double max = m_slider1.GetRangeMax();
         double cur = m_slider1.GetPos();
         double res = _veMin + ((_veMax - _veMin) * ((cur - min) / (max - min)));
         _demView->setVertExag(res);
      }	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

BOOL VertExagDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

   m_slider1.SetRangeMin(0);
   m_slider1.SetRangeMax(100);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

int VertExagDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	return 0;
}

void VertExagDlg::OnButton1() 
{
   // Reset vertical exageration to 1.0
   
   _demView->setVertExag(1.0);   	
   update();
}

void VertExagDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
   // XXX We only one of HScroll or VScroll. When I know
   // XXX which I like better, I'll remove the other.	
   if (_demView != 0)
      {
         double min = m_slider1.GetRangeMin();
         double max = m_slider1.GetRangeMax();
         double cur = m_slider1.GetPos();
         double tmp = 1.0 - ((cur - min) / (max - min));
         double ve = _veMin + ((_veMax - _veMin) * tmp);
         _demView->setVertExag(ve);
      }	

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}
