// dem3d.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "dem3d.h"

#include "MainFrm.h"
#include "dem3dDoc.h"
#include "dem3dView.h"
#include "OpenGLView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDem3dApp

BEGIN_MESSAGE_MAP(CDem3dApp, CWinApp)
	//{{AFX_MSG_MAP(CDem3dApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDem3dApp construction

CDem3dApp::CDem3dApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance

   // Notify the user if a new version is likely available for
   // download if this is a beta version.
#if 0
   CTime currentTime = CTime::GetCurrentTime();
   CTime badTime( 1998, 2, 28, 0, 0, 0 );
   if ( currentTime > badTime )
      {
         CString message;
         UINT flags = MB_OK | MB_ICONWARNING;
         message  = "This beta version of dem3d has EXPIRED!  We ";
         message += "expire beta versions of our software in an attempt ";
         message += "to eliminate versions known to contain untested ";
         message += "features.  If you wish to continue using dem3d, ";
         message += "please download either the latest beta version ";
         message += "(which will also eventually expire) or the latest ";
         message += "production version (which will NOT expire) from ";
         message += "ftp://ftpmcmc.er.usgs.gov/release/viewers/dem3d.";
         ::MessageBox( NULL, message, "Beta Expired!", flags );

         // Exit the program
         ::ExitProcess(1);
     }
  else
     {
         CString message;
         UINT flags = MB_OK | MB_ICONINFORMATION;
         message  = "This is a BETA version of dem3d.  'Beta' means ";
         message += "that it is untested.  It may have serious, even ";
         message += "fatal bugs.  It may also have features that will ";
         message += "not appear in the final release.  Use at your own ";
         message += "risk.\n\n";
         message += "We release beta versions in an attempt to find as many ";
         message += "bugs as possible before distributing dem3d to a ";
         message += "wider audience.  You can help us by reporting any ";
         message += "problems you have with this version to lmoore@usgs.gov.  ";
         message += "Please include the following version number:  v0.9.\n\n";
         message += "This version of dem3d will expire (cease to ";
         message += "function) on February 28, 1998!  At that time, download ";
         message += "either the latest beta version (which will also ";
         message += "eventually expire) or the latest production version ";
         message += "(which will NOT expire) from ";
         message += "ftp://ftpmcmc.er.usgs.gov/release/viewers/dem3d.";
         ::MessageBox( NULL, message, "Warning - Beta Version", flags );
     }
#endif
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CDem3dApp object

CDem3dApp theApp;

// This identifier was generated to be statistically unique for your app.
// You may change it if you prefer to choose a specific identifier.

// {E0AB4205-ABDE-11D0-80AB-02608CDA2E56}
static const CLSID clsid =
{ 0xe0ab4205, 0xabde, 0x11d0, { 0x80, 0xab, 0x2, 0x60, 0x8c, 0xda, 0x2e, 0x56 } };

/////////////////////////////////////////////////////////////////////////////
// CDem3dApp initialization

BOOL CDem3dApp::InitInstance()
{
	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("USGS-NMD-MCMC-RTA-SES"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CDem3dDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CDem3dView));
	AddDocTemplate(pDocTemplate);

	// Connect the COleTemplateServer to the document template.
	//  The COleTemplateServer creates new documents on behalf
	//  of requesting OLE containers by using information
	//  specified in the document template.
	m_server.ConnectTemplate(clsid, pDocTemplate, TRUE);
		// Note: SDI applications register server objects only if /Embedding
		//   or /Automation is present on the command line.

	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Check to see if launched as OLE server
	if (cmdInfo.m_bRunEmbedded || cmdInfo.m_bRunAutomated)
	{
		// Register all OLE server (factories) as running.  This enables the
		//  OLE libraries to create objects from other applications.
		COleTemplateServer::RegisterAll();

		// Application was run with /Embedding or /Automation.  Don't show the
		//  main window in this case.
		return TRUE;
	}

	// When a server application is launched stand-alone, it is a good idea
	//  to update the system registry in case it has been damaged.
	m_server.UpdateRegistry(OAT_DISPATCH_OBJECT);
	COleObjectFactory::UpdateRegistryAll();

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	void setDem3dView(CDem3dView* dem3dView);
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	bool _inEasterEgg;
	CDem3dView* _dem3dView;
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
	_inEasterEgg = 0;
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CDem3dApp::OnAppAbout()
{
	aboutDlg = new CAboutDlg();
	aboutDlg->setDem3dView(_dem3dView);
	aboutDlg->Create(IDD_ABOUTBOX);
	aboutDlg->ShowWindow(SW_SHOW);
}

/////////////////////////////////////////////////////////////////////////////
// CDem3dApp commands

BOOL CDem3dApp::OnIdle(LONG lCount) 
{
	long retval1 = CWinApp::OnIdle(lCount);

   long retval2 = 0;
   if (_oglView != 0)
      retval2 = _oglView->OnIdle(lCount);

   return retval1 + retval2;
}

void
CDem3dApp::setOpenGLView(COpenGLView* oglView)
{
   _oglView = oglView;
}

void CAboutDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (! ((nFlags & MK_CONTROL) && (nFlags & MK_SHIFT)))
		return;
	_inEasterEgg = true;

	CDialog::OnLButtonDown(nFlags, point);
}

void CDem3dApp::setDem3dView(CDem3dView * dem3dView)
{
	_dem3dView = dem3dView;
}

void CAboutDlg::setDem3dView(CDem3dView * dem3dView)
{
	_dem3dView = dem3dView;
}

void CAboutDlg::OnOK() 
{
	CDialog::OnOK();
}