

#include "stdafx.h"


double
getScaledValue(CSliderCtrl const& slider, double min, double max)
{
   double sliderMax = slider.GetRangeMax();
   double sliderMin = slider.GetRangeMin();
   double sliderCur = slider.GetPos();
   double p = (sliderCur - sliderMin) / (sliderMax - sliderMin);   
   return ((max - min) * p) + min;
}

void
setScaledValue(CSliderCtrl& slider,
               double min, double max, double val)
{
   // Assumes min <= val <= max.
   // Maps min to slider min, max to slider max and sets the slider
   // cursor to val's position.

   double sliderMax = slider.GetRangeMax();
   double sliderMin = slider.GetRangeMin();
   double p = (val - min) / (max - min);
   slider.SetPos(static_cast<long>(((sliderMax - sliderMin) * p) + sliderMin));
}              