
#ifndef INCLUDED_SG_COMPASS_HXX
#define INCLUDED_SG_COMPASS_HXX

#ifndef INCLUDED_SG_SHAPE_HXX
#include "scenegraph/sg_Shape.hxx"
#endif

class sg_Win32Font;
class sg_CompositeNode;

class sg_Compass : public sg_Shape
{
   public:

      sg_Compass(sg_Win32Font const* font,   // font for labels.
                 long radius = 1.0,
                 long numTicks = 8,
                 long tickWidth = 0.1,
                 long tickHeight = 0.5);

      ~sg_Compass();

      long render(long previousStep = 0);

   private:
      sg_Win32Font const* _font;
      sg_CompositeNode* _compassRoot;

};

#endif  // INCLUDED_SG_SHAPE_HXX
