
#ifndef INCLUDED_SG_WIN32TEXT_HXX
#include "sg_Win32Text.hxx"
#endif

#ifndef INCLUDED_SG_WIN32FONT_HXX
#include "sg_Win32Font.hxx"
#endif

sg_Win32Text::sg_Win32Text(sg_Win32Font const* font,
                 const string& text)
            : _font(font)
{
   setText(text);
}

void
sg_Win32Text::setText(string const& text)
{
   _text = text;

   if (_font == 0)
      return;

   _min_x = 0.0;
   _min_y = 0.0;
   _min_z = 0.0;
   _max_z = -1 * _font->getExtrudeDepth();

   // Calculate the bounding box.

   _max_x = 0.0;
   _max_y = 0.0;
   GLYPHMETRICSFLOAT const * gmf = _font->getGMF();
   for (long i = 0; i < text.size(); i++)
      {
         if (gmf[text[i]].gmfCellIncY > _max_y)
            _max_y = gmf[text[i]].gmfCellIncY;
         _max_x = _max_x + gmf[text[i]].gmfCellIncX;
      }
}

long
sg_Win32Text::render(long previousStep)
{
   if (_font == 0)
      return 0;

   glEnable(GL_NORMALIZE);  // Scaling text messes up the normals.
   glCullFace(GL_BACK); 
   glEnable(GL_CULL_FACE);
   glListBase(_font->getListBase());
   glCallLists(_text.length(), GL_UNSIGNED_BYTE, _text.c_str() );
   glDisable(GL_CULL_FACE);
   glDisable(GL_NORMALIZE);
   return 0;
}