#ifndef INCLUDED_DEMTYPES_HXX
#include "dem/DEMTypes.hxx"
#endif

#ifndef INCLUDED_DEMPOINT_HXX
#include "dem/DEMPoint.hxx"
#endif

#ifndef INCLUDED_HF_DEM_HXX
#include "heightfield/hf_DEM.hxx"
#endif

hf_DEM::hf_DEM()
		: _height(0),
		  _width(0),
		  _xRes(0),
		  _yRes(0),
		  _zRes(0),
		  _missingData(0),
		  _units(hf_DEM::METERS),
		  _firstTime(true),
        _levelCode(0),
        _elevPattern(0),
        _groundRefSysCode(0),
        _groundRefSysZone(0),
        _groundRefSysUnits(0),
        _numProfiles(0)
{
}

hf_DEM::~hf_DEM()
{
}

long
hf_DEM::getMaxElev() const
{
	return _maxElev;
}

long
hf_DEM::getMinElev() const
{
	return _minElev;
}

long
hf_DEM::getHeight() const
{
	return _height;
}

long
hf_DEM::getWidth() const
{
	return _width;
}

double
hf_DEM::getXRes() const
{
	return _xRes;
}

double
hf_DEM::getYRes() const
{
	return _yRes;
}

double
hf_DEM::getZRes() const
{
	return _zRes;
}

double
hf_DEM::getMissingData() const
{
	return _missingData;
}

hf_DEM::WorldUnits
hf_DEM::getWorldUnits() const
{
	return _units;
}

hf_DEM::HEIGHTFIELDTYPE
hf_DEM::getHeightfieldType() const
{
   return _type;
}

string const&
hf_DEM::getMappingCenterCode() const
{
   return _mapCenterCode;
}

string const&
hf_DEM::getLogicalComment() const
{
   return _logicalComment;
}

string const&
hf_DEM::getPositionalComment() const
{
   return _positionalComment;
}

string const&
hf_DEM::getLineageComment() const
{
   return _lineageComment;
}

long
hf_DEM::getLevelCode() const
{
   return _levelCode;
}
         
long
hf_DEM::getElevPattern() const
{
   return _elevPattern;
}

long
hf_DEM::getGroundRefSysCode() const
{
   return _groundRefSysCode;
}
    
long
hf_DEM::getGroundRefSysZone() const
{
   return _groundRefSysZone;
}

long
hf_DEM::getGroundRefSysUnits() const
{
   return _groundRefSysUnits;
}

DEMPointVector const&
hf_DEM::getDEMCorners() const
{
    return _points;
}

long
hf_DEM::getProfileColumns() const
{
   return _numProfiles;
}
