#ifndef INCLUDED_HF_USGSDEM_HXX
#define INCLUDED_HF_USGSDEM_HXX

#ifndef INCLUDED_HF_DEM_HXX
#include "heightfield/hf_DEM.hxx"
#endif

#ifndef INCLUDED_DEMGRID_HXX
#include "dem/DEMGrid.hxx"
#endif


#ifdef WIN32
#include <iostream>
#include <fstream>
	using namespace std;
#else
#include <iostream.h>
#include <fstream.h>
#endif

class DEMHeader;

class hf_usgsDEM : public hf_DEM
{
public:
	hf_usgsDEM();
	~hf_usgsDEM();

	long
	fill(const string& filename);

	double
	getElev(double x,double y) const;

	void
	getWorldCoords(long, long, double&, double&);

   double*
   getBoundingRect() const;

	string
	getQuadName() const;

   DEMHeader 
   getHeader() const;

private:
	DEMGrid* _demGrid;
   DEMHeader _demHeader;
   ifstream _demfile;
   double* _boundingRect;
};

inline
double
hf_usgsDEM::getElev(double x, double y) const
{
	return _demGrid->getElevation(x,y);
}

inline
double*
hf_usgsDEM::getBoundingRect() const
{
   return _boundingRect;
}


inline
void
hf_usgsDEM::getWorldCoords(long, long, double&, double&) 
{
}

inline
string
hf_usgsDEM::getQuadName() const
{
	return _quadName;
}

#endif //INCLUDED_HF_USGSDEM_HXX
