// $ID$
#ifndef INCLUDED_SG_APPEARANCE
#define INCLUDED_SG_APPEARANCE

#ifdef WIN32
#include <afxwin.h>
#include <afxext.h>
#include <afxtempl.h>
#endif

#ifndef INCLUDED_SG_TYPES_HXX
#include "scenegraph/sg_Types.hxx"
#endif

class sg_Appearance
{
   public:

      sg_Appearance();
      ~sg_Appearance();

      // Accessors

      // Modifiers

      void setColor(sg_RGBA const& rgba);
      void setColor(double r, double g, double b, double a = 1.0);
        // Sets color for object

      enum ShadingStyle {FLAT,SMOOTH};

      void setShadingStyle(ShadingStyle style);
      ShadingStyle getShadingStyle() const;

      void setLighting(bool flag);
         // true - Lighting enabled.
         // false - Lighting disabled.

      bool isLit() const;
         // Returns true if lighting is on.
         // Returns false if lighting is off.

      enum PolygonMode {LINE, FILL};
      PolygonMode getPolygonMode() const;

      void setPolygonMode(PolygonMode mode);

      void setShininess(double shininess);
         // 0.0 <= shininess <= 128.0
         // Default: 0.0

      double getShininess() const;


      void setSpecularColor(sg_RGBA const& specColor);
         // Default: (0.0, 0.0, 0.0, 1.0)

      sg_RGBA const& getSpecularColor() const;


      void apply();

   private:
      sg_RGBA _color;                  bool _colorShadow;
      ShadingStyle _style;             bool _styleShadow;
      bool _lighting;                  bool _lightingShadow;
      PolygonMode _polyMode;           bool _polyModeShadow;
      double _shininess;
      sg_RGBA _specularColor;
};

#endif  // INCLUDED_SG_APPEARANCE
