// $Id: sg_Matrix.cxx,v 1.1.1.1 1997/01/08 21:54:12 pjgray Exp $

#ifndef INCLUDED_SG_MATRIX_HXX
#include "scenegraph/sg_Matrix.hxx"
#endif

static
double sg_IdentityMatrix[16] = {
   1.0, 0.0, 0.0, 0.0,
   0.0, 1.0, 0.0, 0.0,
   0.0, 0.0, 1.0, 0.0,
   0.0, 0.0, 0.0, 1.0
};

sg_Matrix::sg_Matrix()
{
   identity();
}

sg_Matrix::sg_Matrix(sg_Matrix const& rhs)
{
   identity();
   loadFromArray(rhs._matrix);
}

sg_Matrix const&
sg_Matrix::operator=(sg_Matrix const& rhs)
{
   if (this == &rhs)
      return *this;

   loadFromArray(rhs._matrix);

   // NOT sure if right.
   return *this;
}

double&
sg_Matrix::operator()(long row, long column)
{
   return _matrix[(column * 4) + row];
}

double
sg_Matrix::operator()(long row, long column) const
{
   return _matrix[(column * 4) + row];
}

void
sg_Matrix::identity()
{
   loadFromArray(sg_IdentityMatrix);
}

void
sg_Matrix::loadFromArray(double const* array)
{
   for (int i = 0; i < 16; i++)
      _matrix[i] = array[i];
}

double const*
sg_Matrix::getArray() const
{
   return _matrix;
}

sg_Matrix const
sg_Matrix::operator*(sg_Matrix const& rhs)
{
   sg_Matrix P;  // Product of this * rhs.
   sg_Matrix& A = *this;

   double ai0, ai1, ai2, ai3;
   for (long i = 0; i < 4; i++)
      {
         ai0 = A(i,0);
         ai1 = A(i,1);
         ai2 = A(i,2);
         ai3 = A(i,3);
         P(i,0) = ai0 * rhs(0,0) + ai1 * rhs(1,0) + ai2 * rhs(2,0) + ai3 * rhs(3,0);
         P(i,1) = ai0 * rhs(0,1) + ai1 * rhs(1,1) + ai2 * rhs(2,1) + ai3 * rhs(3,1);
         P(i,2) = ai0 * rhs(0,2) + ai1 * rhs(1,2) + ai2 * rhs(2,2) + ai3 * rhs(3,2);
         P(i,3) = ai0 * rhs(0,3) + ai1 * rhs(1,3) + ai2 * rhs(2,3) + ai3 * rhs(3,3);
   }

   return P;
}