#ifndef INCLUDED_SG_MATRIX_HXX
#define INCLUDED_SG_MATRIX_HXX

// $Id: sg_Matrix.hxx,v 1.1.1.1 1997/01/08 21:54:12 pjgray Exp $

#ifndef INCLUDED_SG_MATRIXUTILS_HXX
#include "scenegraph/sg_MatrixUtils.hxx"
#endif

class sg_Matrix
{
   public:

      sg_Matrix();
      sg_Matrix(sg_Matrix const& rhs);
      sg_Matrix const& operator=(sg_Matrix const& rhs);

      double& operator()(long row, long column);
      double operator()(long row, long column) const;

      void identity();
         // Sets Matrix to the identity.

      sg_Matrix const operator*(sg_Matrix const& rhs);
         // Matrix multiplication. result = this * matrix.

      void loadFromArray(double const* array);
         // array is a 4x4 column major array of values to set this matrix to.

      double const* getArray() const;
         // Returns a pointer to a 4x4 column major array of values representing
         // this matrix. Valid until the next non-const operation on this matrix.

   protected:

      double _matrix[16];   // Accessed as a 4x4 column major matrix.

      friend class sg_MatrixUtils;
};

#endif  // INCLUDED_SG_MATRIX_HXX
