
#ifndef INCLUDED_SG_QUATERNION_H
#define INCLUDED_SG_QUATERNION_H

#ifndef INCLUDED_SG_VECTOR_HXX
#include "scenegraph/sg_Vector.hxx"
#endif

#ifndef INCLUDED_SG_MATRIX_HXX
#include "scenegraph/sg_Matrix.hxx"
#endif

class sg_Quaternion  
{
   public:
   	sg_Quaternion();

      sg_Quaternion(double theta, sg_Vector const& axis);
         // Constructs a quaternion from a rotation of 
         // theta degrees around the given axis.
         // Theta is in radians.

      sg_Quaternion const& operator=(sg_Quaternion const& rhs);
      sg_Quaternion(sg_Quaternion const& rhs);

      void normalize();

      sg_Matrix getMatrix() const;

   	~sg_Quaternion();

      friend sg_Quaternion const&
      operator+(sg_Quaternion const& left, sg_Quaternion const& right);
    
   private:
      
      sg_Vector _v;      // The vector part of the quaternion
      double    _s;      // The scalar part.
};

sg_Quaternion const&
operator+(sg_Quaternion const& left,
          sg_Quaternion const& right);

#endif  // INCLUDED_SG_QUATERNION_H

