
// $Id: sg_SceneNodePtr.cxx,v 1.1.1.1 1997/01/08 21:54:13 pjgray Exp $

#ifndef INCLUDED_SG_SCENENODEPTR_HXX
#include "scenegraph/sg_SceneNodePtr.hxx"
#endif

#ifndef INCLUDED_SG_SCENENODE_HXX
#include "scenegraph/sg_SceneNode.hxx"
#endif

sg_SceneNodePtr::sg_SceneNodePtr()
               : d_actualObject(0)
{
}

sg_SceneNodePtr::sg_SceneNodePtr(sg_SceneNodePtr const& right)
               : d_actualObject(0)
{
   operator=(right);
}

sg_SceneNodePtr::sg_SceneNodePtr(sg_SceneNode* obj)
               : d_actualObject(0)
{
   d_actualObject = obj;
}

sg_SceneNodePtr::~sg_SceneNodePtr()
{
}

bool
sg_SceneNodePtr::operator==(sg_SceneNodePtr const& right) const
{
   // Two sg_SceneNodePtrs are equal if they point to the same object.
   if (this == &right)
      return true;
   return d_actualObject == right.d_actualObject;
}

sg_SceneNodePtr const&
sg_SceneNodePtr::operator=(sg_SceneNodePtr const& right)
{
   if (this == &right) return *this;

   d_actualObject = right.d_actualObject;

   return *this;
}


void
sg_SceneNodePtr::setObject(sg_SceneNode* obj)
{
   d_actualObject = obj;
}

sg_SceneNode*
sg_SceneNodePtr::operator->()
{
   return d_actualObject;
}

sg_SceneNode&
sg_SceneNodePtr::operator*()
{
   return *d_actualObject;
}

sg_SceneNode const*
sg_SceneNodePtr::operator->() const
{
   return d_actualObject;
}

sg_SceneNode const&
sg_SceneNodePtr::operator*() const
{
   return *d_actualObject;
}