
// $Id: sg_SceneVisitor.cxx,v 1.2 1997/01/29 19:39:15 moyers Exp $
#ifdef WIN32
#include <iostream>
#else
#include <iostream.h>
#include <iomanip.h>
#endif

#ifndef INCLUDED_SG_SCENEVISITOR_HXX
#include "scenegraph/sg_SceneVisitor.hxx"
#endif

#ifndef INCLUDED_SG_SCENENODE_HXX
#include "scenegraph/sg_SceneNode.hxx"
#endif

#ifndef INCLUDED_SG_SHAPE_HXX
#include "scenegraph/sg_Shape.hxx"
#endif

sg_SceneVisitor::sg_SceneVisitor()
{
}

void
sg_SceneVisitor::visitShapeNode(sg_ShapeNode* node)
{
}

void
sg_SceneVisitor::visitCompositeNode(sg_CompositeNode* node)
{
}

void
sg_SceneVisitor::visitLightNode(sg_LightNode* node)
{
}

void
sg_SceneVisitor::visitManipulatorNode(sg_ManipulatorNode* node)
{
}

void
sg_SceneVisitor::visitCameraNode(sg_CameraNode* node)
{
}

// sg_TreePrintVisitor

sg_TreePrintVisitor::sg_TreePrintVisitor()
{
}

void
sg_TreePrintVisitor::visitShapeNode(sg_ShapeNode* node)
{
   cout << "Shape Node\n";
}

void
sg_TreePrintVisitor::visitCompositeNode(sg_CompositeNode* node)
{
   cout << "Composite Node\n";
}

void
sg_TreePrintVisitor::visitLightNode(sg_LightNode* node)
{
   cout  << "Light Node\n";
}

void
sg_TreePrintVisitor::visitManipulatorNode(sg_ManipulatorNode* node)
{
   cout << "Manipulator Node\n";
}

// sg_RenderVisitor

sg_RenderVisitor::sg_RenderVisitor()
                : _finished(true),
                  _prevShapeNode(0),
                  _prevStep(0)
{
}

void
sg_RenderVisitor::visitShapeNode(sg_ShapeNode* node)
{
   if (node != _prevShapeNode)
      {
         _finished = false;
         _prevStep = 0;
         _prevShapeNode = node;
      }

   node->sg_SceneNode::render();
   _prevStep = (node->getShape())->render(_prevStep);
   if (_prevStep == 0)
      _finished = true;
}

void
sg_RenderVisitor::visitCompositeNode(sg_CompositeNode* node)
{
   node->render();
   _finished = true;
}

void
sg_RenderVisitor::visitLightNode(sg_LightNode* node)
{
   node->render();
   _finished = true;
}

void
sg_RenderVisitor::visitManipulatorNode(sg_ManipulatorNode* node)
{
   node->render();
   _finished = true;
}

void
sg_RenderVisitor::visitCameraNode(sg_CameraNode* node)
{
   node->render();
   _finished = true;
}

bool sg_RenderVisitor::finishedWithNode()
{
   return _finished;
}


// sg_LoResRenderVisitor

sg_LoResRenderVisitor::sg_LoResRenderVisitor()
{
}

void
sg_LoResRenderVisitor::visitShapeNode(sg_ShapeNode* node)
{
   node->renderLoRes();
}

void
sg_LoResRenderVisitor::visitCompositeNode(sg_CompositeNode* node)
{
   node->render();
}

void
sg_LoResRenderVisitor::visitLightNode(sg_LightNode* node)
{
   node->render();
}

void
sg_LoResRenderVisitor::visitManipulatorNode(sg_ManipulatorNode* node)
{
   node->render();
}

void
sg_LoResRenderVisitor::visitCameraNode(sg_CameraNode* node)
{
   node->render();
}

// sg_StepCountVisitor

sg_StepCountVisitor::sg_StepCountVisitor()
                   : _stepCount(0)
{
}

long
sg_StepCountVisitor::getTotalSteps()
{
   return _stepCount;
}

void
sg_StepCountVisitor::visitShapeNode(sg_ShapeNode* node)
{
   _stepCount = _stepCount + node->getShape()->getCurrentRenderSteps();
}

void
sg_StepCountVisitor::visitCompositeNode(sg_CompositeNode* node)
{
   _stepCount = _stepCount + 1;
}

void
sg_StepCountVisitor::visitLightNode(sg_LightNode* node)
{
   _stepCount = _stepCount + 1;
}

void
sg_StepCountVisitor::visitManipulatorNode(sg_ManipulatorNode* node)
{
   // Nothing.
}


void
sg_StepCountVisitor::visitCameraNode(sg_CameraNode* node)
{
   _stepCount = _stepCount + 1;
}


