
// $Id: sg_Transformation.cxx,v 1.1.1.1 1997/01/08 21:54:14 pjgray Exp $

#include <math.h>

#ifndef INCLUDED_SG_TRANSFORMATION
#include "scenegraph/sg_Transformation.hxx"
#endif

#ifndef INCLUDED_SG_TYPES_HXX
#include "scenegraph/sg_Types.hxx"
#endif

sg_Transformation::sg_Transformation()
{
}

sg_Transformation::~sg_Transformation()
{
}

sg_Matrix const&
sg_Transformation::getMatrix() const
{
   return _matrix;
}

void
sg_Transformation::transformPoint(sg_Point const& p, sg_Point& q)
{
   sg_MatrixUtils::transformPoint(_matrix,p,q);
}

void
sg_Transformation::setMatrix(sg_Matrix const& matrix)
{
   _matrix = matrix;
}

void
sg_Transformation::identity()
{
   _matrix.identity();
}

void
sg_Transformation::rotate(double angle, double x, double y, double z)
{
   sg_MatrixUtils::rotateMatrix(_matrix,angle,x,y,z);
}

void
sg_Transformation::translate(double dx, double dy, double dz)
{
   sg_MatrixUtils::translateMatrix(_matrix,dx,dy,dz);
}
   
void
sg_Transformation::scale(double sx, double sy, double sz)
{
   sg_MatrixUtils::scaleMatrix(_matrix,sx,sy,sz);
}
