#ifndef INCLUDED_SG_TRANSFORMATION
#define INCLUDED_SG_TRANSFORMATION

// $Id: sg_Transformation.hxx,v 1.1.1.1 1997/01/08 21:54:14 pjgray Exp $

#ifndef INCLUDED_SG_MATRIX
#include "scenegraph/sg_Matrix.hxx"
#endif

class sg_Point;

class sg_Transformation
{
   public:

      sg_Transformation();
      ~sg_Transformation();

      // Accessors
      sg_Matrix const& getMatrix() const;
         // Returns a matrix equivalent to the current transformation.

      void transformPoint(sg_Point const& p, sg_Point& q);
         // Transforms point p by transformation giving point q.


      // Modifiers
      void setMatrix(sg_Matrix const& matrix);

      void identity();
         // Resets the transformation to the identity transformation.

      void rotate(double angle, double x, double y, double z);
         // Rotation about a line from the origin to the point (x,y,z) by
         // angle 'angle'.

      void translate(double dx, double dy, double dz);
   
      void scale(double sx, double sy, double sz);

   private:

      sg_Matrix _matrix;
};

#endif  // INCLUDED_SG_TRANSFORMATION
