#ifndef INCLUDED_SG_TYPES_HXX
#define INCLUDED_SG_TYPES_HXX

#ifdef WIN32
#include <afxwin.h>
#include <afxext.h>
#include <afxtempl.h>
#endif

#include "GL/gl.h"

class sg_MinBoundBox
{
   public:
      sg_MinBoundBox(double minx = 0.0, double miny = 0.0, double minz = 0.0,
                     double maxx = 0.0, double maxy = 0.0, double maxz = 0.0)
         : min_x(minx), min_y(miny), min_z(minz),
           max_x(maxx), max_y(maxy), max_z(maxz) {}

      double min_x, min_y, min_z;
      double max_x, max_y, max_z;
};

class sg_Point
{
   public:
      sg_Point(double xv = 0.0, double yv = 0.0, double zv = 0.0)
         : x(xv), y(yv), z(zv) {}
      double x,y,z;
};

struct sg_RGBA
{
   public:
      sg_RGBA() {}

      sg_RGBA(GLfloat r, GLfloat g, GLfloat b, GLfloat a = 1.0)
         : red(r), green(g), blue(b), alpha(a) {}

      void getArray(GLfloat* array)
         {
            array[0] = red;
            array[1] = green;
            array[2] = blue;
            array[3] = alpha;
         }

      GLfloat red;
      GLfloat green;
      GLfloat blue;
      GLfloat alpha;
	  bool operator<(sg_RGBA const& rhs) const {return false;}
	  bool operator==(sg_RGBA const& rhs) const {return false;}

};

#endif  // INCLUDE_SG_TYPES_HXX
