#ifndef INCLUDED_SG_UTILS_HXX
#define INCLUDED_SG_UTILS_HXX

// $Id: sg_Utils.hxx,v 1.1 1997/02/07 00:58:54 moyers Exp $

class sg_Point;
class sg_CameraNode;
class sg_Vector;
class sg_MinBoundBox;
class sg_Point;

class sg_Utils
{
   public:

      static
      void calcSpherical(sg_Point const& p,
                         double& radius,
                         double& altitude,
                         double& azimuth);
         // 0.0 <= radius
         // -90.0 <= altitude <= 90.0
         // 0.0 <= azimuth < 360.0

      static
      void calcGoodViewPoint(sg_CameraNode const* camera,
                             sg_Vector const& lookvec,
                             sg_MinBoundBox const& mbb,
                             sg_Point& viewPoint);
         // Calculates a "good" point from which to view the entire
         // bounding box mbb. 'lookvec' is a vector in the desired direction
         // of view. 'viewPoint' is calculated by backing up along lookvec
         // until the entire MBR is visible in the camera.

   private:
      sg_Utils();
};

#endif  // INCLUDED_SG_UTILS_HXX
