#ifndef INCLUDED_SG_VECTOR_HXX
#define INCLUDED_SG_VECTOR_HXX

class sg_Vector
{
   public:
      sg_Vector();
      sg_Vector(double i, double j, double k);
      sg_Vector(sg_Vector const& rhs);
      sg_Vector const& operator=(sg_Vector const& rhs);

      sg_Vector const operator+(sg_Vector const& rhs) const;

      sg_Vector const operator-(sg_Vector const& rhs) const;

      sg_Vector const operator*(double s) const;
         // Scalar product

      sg_Vector const cross(sg_Vector const& rhs) const;
         // Cross product

      double dot(sg_Vector const& rhs) const;

      void normalize();

      void getComponents(double& i, double& j, double& k) const;

   private:

      double _i,_j,_k;
};

#endif  // INCLUDED_SG_VECTOR_HXX
