
#include "scenegraph/sg_hsv.h"

void
sg_hsv2rgb(double hue, double saturation, double value,
           double& red, double& green, double& blue)
{
   // 0.0 <= hue <= 360.0
   // 0.0 <= saturation <= 1.0
   // 0.0 <= value <= 1.0
   // 0.0 <= red <= 1.0
   // 0.0 <= green <= 1.0
   // 0.0 <= blue <= 1.0

   // Stolen and modified from xscreensaver 1.22.

   double H, S, V, R, G, B;
   double p1, p2, p3;
   double f;
   int i;

   S = saturation;
   V = value;
   H = hue / 60.0;
   i = H;
   f = H - i;
   p1 = V * (1 - S);
   p2 = V * (1 - (S * f));
   p3 = V * (1 - (S * (1 - f)));
   if      (i == 0) { R = V;  G = p3; B = p1; }
   else if (i == 1) { R = p2; G = V;  B = p1; }
   else if (i == 2) { R = p1; G = V;  B = p3; }
   else if (i == 3) { R = p1; G = p2; B = V;  }
   else if (i == 4) { R = p3; G = p1; B = V;  }
   else             { R = V;  G = p1; B = p2; }

   red = R;
   green = G;
   blue = B;
}