
#ifdef _MSC_VER
#include <string>
#include <iostream>
#include <fstream>
   using namespace std;
#else
 #include <iostream.h>
 #include <fstream.h>
 #include <string>
#endif

// CCC change below
#define SB_DATADICTDOM_TEST
#define SB_OBJECT_TEST

#include "build_test/t_sb_output.h"


// binary 32 bit integer converter function
sio_Converter_BI32  bi32_converter;

int
main( int argc, char** argv )
{
	// CCC change below
	sb_DataDictDom *aSBobject;
    //to do a raw subfield dump (if true ) or just a builder dump if false )
	bool checkRawSubfield = false;
	string filename;
	
	if ( argc == 3 && (strcmp(argv[1], "-check") == 0 ) ) { 
    
		checkRawSubfield = true;
	    filename = argv[2] ; 

	} else if ( argc == 2 && argv[1][0] != '-' ){
		
		// Default value: checkRawSubfield = false;
		filename = string( argv[1] ); 

	}else {

    	cerr << "usage: "
             << argv[0] << " [-check] 8211file " << endl;
	    return 1;

	}

    ifstream ddf( filename.c_str() , ios::binary );

	if ( ! ddf ) 
	{
		cerr << "couldn't open "
			<< filename  << endl;
		return 2;
	}

	map<string, sio_Converter*> converters;

	converters["X"] = &bi32_converter;
	converters["Y"] = &bi32_converter;

	
	sio_8211Reader  reader( ddf, &converters );

	sc_Record record;

        for( sio_8211ForwardIterator i( reader );
	                ! i.done();
	                ++i )
	{
		i.get( record );
		// CCC change below
		aSBobject = new sb_DataDictDom( record );

		if ( checkRawSubfield ){
			cout << "Raw io dump***\n";
			dumpRecord( record );
			cout << "\n***\n";
		}

		dumpSbObject( *aSBobject );

	        delete aSBobject;
	}

	return 0;
}

