
#ifdef _MSC_VER
#include <iostream>
#include <fstream>
   using namespace std;
#else
#include <iostream.h>
#include <fstream.h>
#endif


#define SB_IDENT_TEST
#define SB_OBJECT_TEST

#include "build_test/t_sb_output.h"


// binary 32 bit integer converter function
sio_Converter_BI32  bi32_converter;


int
main( int argc, char** argv )
{
	sb_Ident *aIdent;


	if ( ! argv[1] ) 
	{
		cerr << "usage: "
			<< argv[0] << " 8211file " << endl;
		return 1;
	}

   ifstream ddf( argv[1], ios::binary );

	if ( ! ddf ) 
	{
		cerr << "couldn't open "
			<< argv[1] << endl;
		return 2;
	}

	map<string, sio_Converter*> converters;

	converters["X"] = &bi32_converter;
	converters["Y"] = &bi32_converter;

	
	sio_8211Reader  reader( ddf, &converters );

	sc_Record record;

        for( sio_8211ForwardIterator i( reader );
	                ! i.done();
			                ++i )
	{
		i.get( record );
		aIdent = new sb_Ident( record );

		dumpRecord( record );
		cout << "\n***\n";
		dumpSbObject( *aIdent );

	        delete aIdent;
	}

	return 0;
}
