#ifndef INCLUDED_T_SB_OUTPUT_H
#define INCLUDED_T_SB_OUTPUT_H

#ifdef _MSC_VER
	#include <iostream>
	using namespace std;
#else
	#include <iostream.h>
#endif


#ifndef INCLUDED_SIO_READER_H
#include "io/sio_Reader.h"
#endif

#ifndef INCLUDED_SIO_8211DIRENTRY_H
#include "io/sio_8211DirEntry.h"
#endif

#ifndef INCLUDED_SIO_CONVERTER_H
#include "io/sio_Converter.h"
#endif

#ifndef INCLUDED_SC_RECORD_H
#include "container/sc_Record.h"
#endif

void dumpSubfield( sc_Subfield const & subfield );
void dumpRecord( sc_Record const & record );


//end container output

#ifdef SB_OBJECT_TEST

// ForeignID
#ifndef INCLUDED_SB_FOREIGNID_HXX
#include "builder/sb_ForeignID.hxx"
#endif

void dumpFID( sb_ForeignID const & temp );
ostream & operator<<( ostream & os, sb_ForeignID const & temp );

// SpatialAddr
#ifndef INCLUDED_SB_SPATIALADDR_HXX
#include "builder/sb_SpatialAddr.hxx"
#endif

void dumpSpatialAddr( sb_SpatialAddr const & temp );
ostream & operator<<( ostream & os, sb_SpatialAddr const & temp );

	#ifdef SB_IDENT_TEST
	      #ifndef INCLUDED_SB_IDENT_HXX
	      #include "builder/sb_Ident.hxx"
	      #endif //INCLUDED_SB_IDENT_HXX

             void dumpSbObject( sb_Ident const & temp ) ;
	      ostream & operator<<( ostream & os, sb_Ident const & temp );
	#endif //SB_IDENT_TEST

	#ifdef SB_TRANSFERSTATS_TEST
	      #ifndef INCLUDED_SB_TRANSFERSTATS_HXX
	      #include "builder/sb_TransferStats.hxx"
	      #endif //INCLUDED_SB_TRANSFERSTATS_HXX

          void dumpSbObject( sb_TransferStats const & temp ) ;
          ostream & operator<<( ostream & os, sb_TransferStats const & temp );
	#endif //SB_TRANSFERSTATS_TEST 

	#ifdef SB_ARC_TEST
	      #ifndef INCLUDED_SB_ARC_HXX
	      #include "builder/sb_Arc.hxx"
	      #endif //INCLUDED_SB_ARC_HXX

          void dumpSbObject( sb_Arc & temp ) ;
          ostream & operator<<( ostream & os, sb_Arc & temp );
	#endif //SB_ARC_TEST 

	#ifdef SB_LINE_TEST
	      #ifndef INCLUDED_SB_LINE_HXX
	      #include "builder/sb_Line.hxx"
	      #endif //INCLUDED_SB_LINE_HXX

          void dumpSbObject( sb_Line  & temp ) ;
          ostream & operator<<( ostream & os, sb_Line & temp );
	#endif //SB_LINE_TEST 

	#ifdef SB_INTSPATIALREF_TEST
	      #ifndef INCLUDED_SB_INTSPATIALREF_HXX
	      #include "builder/sb_IntSpatialRef.hxx"
	      #endif //INCLUDED_SB_INTSPATIALREF_HXX

          void dumpSbObject( sb_IntSpatialRef & temp ) ;
          ostream & operator<<( ostream & os, sb_IntSpatialRef & temp );
	#endif //SB_INTSPATIALREF_TEST 

	#ifdef SB_POLYGON_TEST
	      #ifndef INCLUDED_SB_POLYGON_HXX
	      #include "builder/sb_Polygon.hxx"
	      #endif //INCLUDED_SB_POLYGON_HXX

          void dumpSbObject( sb_Polygon & temp ) ;
          ostream & operator<<( ostream & os, sb_Polygon & temp );
	#endif //SB_POLYGON_TEST 

	#ifdef SB_POINTNODE_TEST
	      #ifndef INCLUDED_SB_POINTNODE_HXX
	      #include "builder/sb_PointNode.hxx"
	      #endif //INCLUDED_SB_POINTNODE_HXX
          void dumpSbObject( sb_PointNode & temp ) ;
          ostream & operator<<( ostream & os, sb_PointNode & temp );
	#endif //SB_POINTNODE_TEST

	#ifdef SB_DATADICTDOM_TEST
	      #ifndef INCLUDED_SB_DATADICTDOM_HXX
	      #include "builder/sb_DataDictDom.hxx"
	      #endif //INCLUDED_SB_DATADICTDOM_HXX
          void dumpSbObject( sb_DataDictDom & temp ) ;
          ostream & operator<<( ostream & os, sb_DataDictDom & temp );
	#endif //SB_DATADICTDOM_TEST 

	#ifdef SB_CATALOGDIR_TEST
	      #ifndef INCLUDED_SB_CATALOGDIR_HXX
	      #include "builder/sb_CatalogDir.hxx"
	      #endif //INCLUDED_SB_CATALOGDIR_HXX
          void dumpSbObject( sb_CatalogDir & temp ) ;
          ostream & operator<<( ostream & os, sb_CatalogDir & temp );
	#endif //SB_CATALOGDIR_TEST 

	#ifdef SB_EXTSPATIALREF_TEST
	      #ifndef INCLUDED_SB_EXTSPATIALREF_HXX
	      #include "builder/sb_ExtSpatialRef.hxx"
	      #endif //INCLUDED_SB_EXTSPATIALREF_HXX
          void dumpSbObject( sb_ExtSpatialRef & temp ) ;
          ostream & operator<<( ostream & os, sb_ExtSpatialRef & temp );
	#endif //SB_EXTSPATIALREF_TEST 

	#ifdef SB_CATALOGSPATIALDOM_TEST
	      #ifndef INCLUDED_SB_CATALOGSPATIALDOM_HXX
	      #include "builder/sb_CatalogSpatialDom.hxx"
	      #endif //INCLUDED_SB_CATALOGSPATIALDOM_HXX
          void dumpSbObject( sb_CatalogSpatialDom & temp ) ;
          ostream & operator<<( ostream & os, sb_CatalogSpatialDom & temp );
	#endif //SB_CATALOGSPATIALDOM_TEST 

	#ifdef SB_CATALOGCROSSREF_TEST
	      #ifndef INCLUDED_SB_CATALOGCROSSREF_HXX
	      #include "builder/sb_CatalogCrossRef.hxx"
	      #endif //INCLUDED_SB_CATALOGCROSSREF_HXX
          void dumpSbObject( sb_CatalogCrossRef & temp ) ;
          ostream & operator<<( ostream & os, sb_CatalogCrossRef & temp );
	#endif //SB_CATALOGCROSSREF_TEST 

	#ifdef SB_DATADICTDEFN_TEST
	      #ifndef INCLUDED_SB_DATADICTDEFN_HXX
	      #include "builder/sb_DataDictDefn.hxx"
	      #endif //INCLUDED_SB_DATADICTDEFN_HXX
          void dumpSbObject( sb_DataDictDefn & temp ) ;
          ostream & operator<<( ostream & os, sb_DataDictDefn & temp );
	#endif //SB_DATADICTDEFN_TEST 

	#ifdef SB_DATADICTSCHEMA_TEST
	      #ifndef INCLUDED_SB_DATADICTSCHEMA_HXX
	      #include "builder/sb_DataDictSchema.hxx"
	      #endif //INCLUDED_SB_DATADICTSCHEMA_HXX
          void dumpSbObject( sb_DataDictSchema & temp ) ;
          ostream & operator<<( ostream & os, sb_DataDictSchema & temp );
	#endif //SB_DATADICTSCHEMA_TEST 

	#ifdef SB_SECURITY_TEST
	      #ifndef INCLUDED_SB_SECURITY_HXX
	      #include "builder/sb_Security.hxx"
	      #endif //INCLUDED_SB_SECURITY_HXX
          void dumpSbObject( sb_Security & temp ) ;
          ostream & operator<<( ostream & os, sb_Security & temp );
	#endif //SB_SECURITY_TEST 

	#ifdef SB_REGISTRATION_TEST
	      #ifndef INCLUDED_SB_REGISTRATION_HXX
	      #include "builder/sb_Registration.hxx"
	      #endif //INCLUDED_SB_REGISTRATION_HXX
          void dumpSbObject( sb_Registration & temp ) ;
          ostream & operator<<( ostream & os, sb_Registration & temp );
	#endif //SB_REGISTRATION_TEST 

	#ifdef SB_RASTER_TEST
	      #ifndef INCLUDED_SB_RASTERDEFN_HXX
	      #include "builder/sb_RasterDefn.hxx"
	      #endif //INCLUDED_SB_RASTERDEFN_HXX
          void dumpSbObject( sb_RasterDefn const& temp ) ;
          ostream & operator<<( ostream & os, sb_RasterDefn const& temp );
	      #ifndef INCLUDED_SB_RASTERLAYER_HXX
	      #include "builder/sb_RasterLayer.hxx"
	      #endif //INCLUDED_SB_RASTERLAYER_HXX
          void dumpSbObject( sb_RasterLayer const& temp ) ;
          ostream & operator<<( ostream & os,
	                        sb_RasterLayer const& temp );
	  ostream& operator<<( ostream & os,
	                       vector<sb_RasterLayer> const& aTempVector);
	#endif //SB_RASTER_TEST 

	#ifdef SB_DIMENDEFN_TEST
	      #ifndef INCLUDED_SB_DIMENDEFN_HXX
	      #include "builder/sb_DimenDefn.hxx"
	      #endif //INCLUDED_SB_DIMENDEFN_HXX
          void dumpSbObject( sb_DimenDefn const& temp ) ;
          ostream & operator<<( ostream & os, sb_DimenDefn const& temp );
	#endif //SB_DIMENDEFN_TEST 

/*  //(yank 7 lines)  Template for new sb Object modules
	#ifdef SB_YYY_TEST
	      #ifndef INCLUDED_SB_YYY_HXX
	      #include "builder/sb_XXX.hxx"
	      #endif //INCLUDED_SB_YYY_HXX
          void dumpSbObject( sb_XXX const& temp ) ;
          ostream & operator<<( ostream & os, sb_XXX const& temp );
	#endif //SB_YYY_TEST 

*/


#endif //SB_OBJECT_TEST

#endif //  INCLUDED_T_SB_OUTPUT_HXX
