
#ifndef INCLUDED_SIO_8211DDRLEADER_H
#include "io/sio_8211DDRLeader.h"
#endif

#ifndef INCLUDED_SIO_8211DIRENTRY_H
#include "io/sio_8211DirEntry.h"
#endif

#ifndef INCLUDED_SIO_8211DIRECTORY_H
#include "io/sio_8211Directory.h"
#endif

#ifndef INCLUDED_SIO_8211DDR_H
#include "io/sio_8211DDR.h"
#endif

istream&
sio_8211DDR::streamExtract(istream& istr)
{
   // Assume istr is positioned on byte zero of an ISO8211 DDR.

   // Get the leader.
   sio_8211DDRLeader* ddrLeader= new sio_8211DDRLeader;
   istr >> *ddrLeader;

   // Get the directory.
   delete _dir;
   _dir = new sio_8211Directory(*ddrLeader);
   istr >> *_dir;

   // Get the fields. 
   long fieldAreaStart = ddrLeader->getBaseAddrOfFieldArea();
   sio_8211Directory::iterator i;
   for (i = _dir->begin(); i != _dir->end(); i++)
      { 
         istr.seekg(fieldAreaStart + (*i)->getPosition());

         string fieldTag = (*i)->getTag();
         _fieldArea.push_back(sio_8211Field((*i)->getFieldLength() - 1));

#if 0
         if (fieldTag.substr(0,3) == "000")  // It's a reserved tag. 
            {
               _fieldArea.push_back(new sio_8211Field((*i)->getFieldLength() - 1));
            }
         else
            {
               // Assume it's a Data Descriptive Field.
               _fieldArea.push_back(new sio_8211DDRField(*ddrLeader,
                                                         (*i)->getFieldLength() - 1));
            }
#endif

         istr >> _fieldArea.back();
         (*i)->setField(&(_fieldArea.back()));
      }

   delete _leader;
   _leader = ddrLeader;

   return istr;
}
