
#ifndef INCLUDED_SIO_8211DDRFIELD_H
#include "io/sio_8211DDRField.h"
#endif

#ifndef INCLUDED_SIO_8211FIELD_H
#include "io/sio_8211Field.h"
#endif

#ifndef INCLUDED_SIO_8211DDRLEADER_H
#include "io/sio_8211DDRLeader.h"
#endif

sio_8211DDRField::sio_8211DDRField(sio_8211DDRLeader const& leader,
                                   sio_8211Field const& field)
                : _fieldControlLength(leader.getFieldControlLength())
{
   char const* data = field.getData();

   _dataStructCode = data[0];
   _dataTypeCode = data[1];

   // Starting at the end of the field controls, look for an optional data field
   // name followed by a unit terminator.

   char tmpbuf[1000];

   long pos = _fieldControlLength;
   if (!field.getVariableSubfield(tmpbuf,pos))
      {
         // XXX Error!
      }
   _fieldName = tmpbuf;

   if (!field.getVariableSubfield(tmpbuf,pos))
      {
         // XXX Error!
      }
   _arrayDescr = tmpbuf;

   if (!field.getVariableSubfield(tmpbuf,pos))
      {
         // XXX Error!
      }
   _formatControls = tmpbuf;
}

char
sio_8211DDRField::getDataStructCode() const
{
   return _dataStructCode;
}

char
sio_8211DDRField::getDataTypeCode() const
{
   return _dataTypeCode;
}

string const&
sio_8211DDRField::getDataFieldName() const
{
   return _fieldName;
}

string const&
sio_8211DDRField::getArrayDescriptor() const
{
   return _arrayDescr;
}

string const&
sio_8211DDRField::getFormatControls() const
{
   return _formatControls;
}

#if 0
istream&
sio_8211DDRField::streamExtract(istream& istr)
{
   // Assume istr is positioned on byte zero of a DDR field.

   // XXX We need some error checking here.
   delete _data;
   _data = new unsigned char[_dataLength];
   istr.read(reinterpret_cast<char*>(_data),_dataLength);

   if (!istr)
      return istr;

   // Gobble up field terminator.
   char tempChar;
   istr.get(tempChar);  // XXX Should check to see if this really _is_ 
                        // XXX a field terminator.

   // Ok. We've got the raw data. Now, break it apart.
   _dataStructCode = _data[0];
   _dataTypeCode = _data[1];

   // Starting at the end of the field controls, look for an optional data field
   // name followed by a unit terminator.

   char tmpbuf[1000];

   if (!getVariableSubfield(tmpbuf,sio_8211UnitTerminator,_fieldControlLength))
      {
         istr.clear(ios::failbit); 
         return istr;
      }
   _fieldName = tmpbuf;

   if (!getVariableSubfield(tmpbuf))
      {
         istr.clear(ios::failbit);
         return istr;
      }
   _arrayDescr = tmpbuf;

   if (!getVariableSubfield(tmpbuf))
      {
         istr.clear(ios::failbit);
         return istr;
      }
   _formatControls = tmpbuf;

   return istr;
}

#endif
