
#ifndef INCLUDED_SIO_8211DDRFIELD_H
#define INCLUDED_SIO_8211DDRFIELD_H

#include <string>

#ifdef WIN32
   using namespace std;
#endif

class sio_8211DDRLeader;
class sio_8211Field;

class sio_8211DDRField
{
   // An sio_8211DDRField is used to interpret the data in a raw
   // sio_8211Field.

   public:

      sio_8211DDRField(sio_8211DDRLeader const& leader,
                                sio_8211Field const& field);

      char getDataStructCode() const;
      char getDataTypeCode() const;

      // XXX There are other values (such as printable graphics) that I'm
      // XXX not interested in right now.

      string const& getDataFieldName() const;
      string const& getArrayDescriptor() const;
      string const& getFormatControls() const;

   protected:

      char _dataStructCode;
      char _dataTypeCode;
      string _fieldName;
      string _arrayDescr;
      string _formatControls;

      long _fieldControlLength;  // From the ddr leader.
};

#endif  // INCLUDED_SIO_8211DDRFIELD_H
