
#ifndef INCLUDED_SIO_8211DDRLEADER_H
#include "io/sio_8211DDRLeader.h"
#endif

#ifndef INCLUDED_SIO_UTILS_H
#include "io/sio_Utils.h"
#endif

sio_8211DDRLeader::sio_8211DDRLeader()
{

}

sio_8211DDRLeader::~sio_8211DDRLeader()
{

}

char
sio_8211DDRLeader::getAppIndicator() const
{
   return _appIndicator;
}

char
sio_8211DDRLeader::getInterchangeLevel() const
{
   return _interchangeLevel;
}

char
sio_8211DDRLeader::getVersionNumber() const
{
   return _verNumber;
}

long
sio_8211DDRLeader::getFieldControlLength() const
{
   return _fieldControlLength;
}

istream&
sio_8211DDRLeader::streamExtract(istream& istr)
{

   // Assume istr is positioned on byte 0 of a DDR Leader. Read the leader,
   // leaving istr positioned on the byte after the last byte in the leader.

   char leader[24];

   istr.read(leader,24);
   if ((istr.gcount() < 24) || (!istr))
      {
         istr.clear(ios::failbit);
         return istr;
      }
      
   _recLength = sio_Utils::getLong(leader,0,5);
   _interchangeLevel = leader[5];
   _leaderIden = leader[6];
   _verNumber = leader[8];
   _appIndicator = leader[9];
   _fieldControlLength = sio_Utils::getLong(leader,10,2);
   _fieldAreaStart = sio_Utils::getLong(leader,12,5);
   _sizeFieldLength = sio_Utils::getLong(leader,20,1);
   _sizeFieldPos = sio_Utils::getLong(leader,21,1);
   _sizeFieldTag = sio_Utils::getLong(leader,23,1);

   return istr;
}

                
