

#ifndef INCLUDED_SIO_8211DR_H

#define INCLUDED_SIO_8211DR_H



#ifndef INCLUDED_SIO_8211RECORD_H

#include "io/sio_8211Record.h"

#endif



#include <iostream>



#ifdef WIN32

   using namespace std;

#endif



class sio_8211DRLeader;

class sio_8211Directory;



class sio_8211DR : public sio_8211Record

{



   public:



      sio_8211DR();

      sio_8211DR(sio_8211DRLeader const& leader,

                 sio_8211Directory const& dir);

         // If we're going to be reading DR's with dropped leaders, we can

         // create an sio_8211DR with the leader and directory to be used.

         // Sets the reuseLeaderAndDirectory flag to 'true'.



      void reuseLeaderAndDirectory(bool flag);

         // If flag == true, will reuse the current leader and directory.

         // If the leader and directory haven't been valued (either by a 

         // previous read operation or through a constructor), subsequent

         // read operations will fail.

         //

         // The default behavior is to _not_ reuse the leader and directory.



      bool isReusingLeaderAndDirectory() const;

         // Returns true if we're reusing the leader and directory for each

         // read operation.



   protected:

      istream& streamExtract(istream& istr);

      ostream& streamInsert(ostream& ostr) const { return ostr; }



      bool _reuseLeaderAndDir;

};



#endif  // INCLUDED_SIO_8211DR_H

