

#ifndef INCLUDED_SIO_8211DRLEADER_H
#include "io/sio_8211DRLeader.h"
#endif

#ifndef INCLUDED_SIO_UTILS_H
#include "io/sio_Utils.h"
#endif

sio_8211DRLeader::sio_8211DRLeader()
{

}

sio_8211DRLeader::~sio_8211DRLeader()
{

}

istream&
sio_8211DRLeader::streamExtract(istream& istr)
{

   // Assume istr is positioned on byte 0 of a DR Leader. Read the leader,
   // leaving istr positioned on the byte after the last byte in the leader.

   char leader[24];

   istr.read(leader,24);
   if ((istr.gcount() < 24) || (!istr))
      {
         istr.clear(ios::failbit);
         return istr;
      }
      
   _recLength = sio_Utils::getLong(leader,0,5);
   _leaderIden = leader[6];
   _fieldAreaStart = sio_Utils::getLong(leader,12,5);
   _sizeFieldLength = sio_Utils::getLong(leader,20,1);
   _sizeFieldPos = sio_Utils::getLong(leader,21,1);
   _sizeFieldTag = sio_Utils::getLong(leader,23,1);

   return istr;
}
