

#ifndef INCLUDED_SIO_8211DIRENTRY_H

#define INCLUDED_SIO_8211DIRENTRY_H



#include <iostream>

#include <string>



#ifdef WIN32

   using namespace std;

#endif



class sio_8211Leader;

class sio_8211Field;



class sio_8211DirEntry;
istream& operator>>(istream& istr, sio_8211DirEntry& dirEntry);

class sio_8211DirEntry

{

   // An ISO8211 Directory Entry.



   public:

      explicit sio_8211DirEntry(sio_8211Leader const& leader);

         // The leader is required to determine the widths of the various

         // subfields in a directory entry. Once the values are determined,

         // the leader is no longer required (may be deleted).



      sio_8211DirEntry(sio_8211DirEntry const& dirEntry);

      sio_8211DirEntry const& operator=(sio_8211DirEntry const& rhs);



      ~sio_8211DirEntry();



      sio_8211Field const* getField() const;

      void setField(sio_8211Field const* field);

         // We keep a ptr to the field we describe. We do _not_ own it.



      long getFieldLength() const;

      long getPosition() const;

      string const& getTag() const;



      



      friend istream& operator>>(istream& istr, sio_8211DirEntry& dirEntry);



   protected:



      long _lengthSize;

      long _posSize;

      long _tagSize;



      long _fieldLength;

      long _fieldPos;

      string _fieldTag;



      sio_8211Field const* _field;



};



//istream& operator>>(istream& istr, sio_8211DirEntry& dirEntry);



#endif  // INCLUDED_SIO_8211DIRENTRY_H

