
#ifndef INCLUDED_SIO_8211DIRECTORY_H
#include "io/sio_8211Directory.h"
#endif

#ifndef INCLUDED_SIO_8211DIRENTRY_H
#include "io/sio_8211DirEntry.h"
#endif

#ifndef INCLUDED_SIO_8211UTILS_H
#include "io/sio_8211Utils.h"
#endif

sio_8211Directory::sio_8211Directory(sio_8211Leader const& leader)
{
   _leader = leader;
}

sio_8211Directory::sio_8211Directory(sio_8211Directory const& dir)
{
   operator=(dir);
}

sio_8211Directory const&
sio_8211Directory::operator=(sio_8211Directory const& rhs)
{
   if (&rhs == this)
      return *this;

   sio_8211Directory::const_iterator i;
   for (i = rhs.begin(); i != rhs.end(); i++)
      {
         this->push_back(new sio_8211DirEntry(**i));
      }

   _leader = rhs._leader;   

   return *this;
}

sio_8211Directory::~sio_8211Directory()
{
   sio_8211Directory::iterator i;
   for (i = this->begin(); i != this->end(); i++)
      {
         delete *i;
      }
}

istream& operator>>(istream& istr, sio_8211Directory& dir)
{
   // Read in the individual directory entries. Assumes the stream is positioned
   // on byte 0 of the first directory entry.

   while ((istr.peek() != sio_8211FieldTerminator) && (istr))
      {
         dir.push_back(new sio_8211DirEntry(dir._leader));
         istr >> *(dir.back());
      }

   if (istr)
      {
         // Gobble up the field terminator at the end of the directory.
         char tempChar;
         istr.get(tempChar);
      }

   return istr;
}