

#ifndef INCLUDED_SIO_8211DIRECTORY_H

#define INCLUDED_SIO_8211DIRECTORY_H



#include <iostream>

#include <vector>



#ifdef WIN32

   using namespace std;

#endif



#ifndef INCLUDED_SIO_8211LEADER_H

#include "io/sio_8211Leader.h"

#endif



class sio_8211DirEntry;

class sio_8211Directory;
istream& operator>>(istream& istr, sio_8211Directory& dir);

class sio_8211Directory : public vector<sio_8211DirEntry*>

{

   public:

      explicit sio_8211Directory(sio_8211Leader const& leader);

         // The leader is required to determine the widths of the various

         // subfields in a directory entry. Once the values are determined,

         // the leader is no longer required (may be deleted).



      sio_8211Directory(sio_8211Directory const& dir);

      sio_8211Directory const& operator=(sio_8211Directory const& rhs);

         // Does a 'deep copy' of the directory contents.



      ~sio_8211Directory();

         // We're storing pointers to instances of sio_8211DirEntry, and

         // not the instances themselves. So, we need to delete those

         // instances since vectors' dtor won't.



      friend istream& operator>>(istream& istr, sio_8211Directory& dir);



   private:



      sio_8211Leader _leader;

};







#endif  // INCLUDED_SIO_8211DIRECTORY_H

