
#ifndef INCLUDED_SIO_8211LEADER_H
#define INCLUDED_SIO_8211LEADER_H

#include <iostream>

#ifdef WIN32
   using namespace std;
#endif

class sio_8211Leader;
istream& operator>>(istream& istr, sio_8211Leader& leader);
ostream& operator<<(ostream& ostr, sio_8211Leader const& leader);

class sio_8211Leader  
{
   // An ISO8211 Record Leader.

   public:

	   sio_8211Leader();
	   virtual ~sio_8211Leader();

      long getRecordLength() const;

      char getLeaderIdentifier() const;

      long getBaseAddrOfFieldArea() const;

      // Entry Map
      long getSizeOfFieldLengthField() const;

      long getSizeOfFieldPosField() const;

      long getSizeOfFieldTagField() const;

      friend istream& operator>>(istream& istr, sio_8211Leader& leader);
      friend ostream& operator<<(ostream& ostr, sio_8211Leader const& leader);

   protected:

      long _recLength;
      char _leaderIden;
      long _fieldAreaStart;
      long _sizeFieldLength;
      long _sizeFieldPos;
      long _sizeFieldTag;

      virtual istream& streamExtract(istream& istr) { return istr; }
      virtual ostream& streamInsert(ostream& ostr) const { return ostr; }

};
/*
istream&
operator>>(istream& istr, sio_8211Leader& leader);

ostream&
operator<<(ostream& ostr, sio_8211Leader const& leader);
*/

#endif // INCLUDED_SIO_8211LEADER_H

