
#ifndef INCLUDED_SIO_8211RECORD_H
#include "io/sio_8211Record.h"
#endif

#ifndef INCLUDED_SIO_8211DIRENTRY_H
#include "io/sio_8211DirEntry.h"
#endif

sio_8211Record::sio_8211Record()
              : _leader(0),
                _dir(0)
{
}         

sio_8211Record::~sio_8211Record()
{
   // Does nothing. Just here so that we can have a virtual destructor.
}

sio_8211Leader const*
sio_8211Record::getLeader() const
{
   return _leader;
}

sio_8211Directory const*
sio_8211Record::getDirectory() const
{
   return _dir;
}

sio_8211FieldArea const&
sio_8211Record::getFieldArea() const
{
   return _fieldArea;
}

istream&
operator>>(istream& istr, sio_8211Record& record)
{
   return record.streamExtract(istr);
}

ostream&
operator<<(ostream& ostr, sio_8211Record const& record)
{
   return record.streamInsert(ostr);
}
