
#ifndef INCLUDED_SIO_8211RECORD_H
#define INCLUDED_SIO_8211RECORD_H

#include <iostream>

#ifdef WIN32
   using namespace std;
#endif

class sio_8211Leader;

#ifndef INCLUDED_SIO_8211DIRECTORY_H
#include "io/sio_8211Directory.h"
#endif

#ifndef INCLUDED_SIO_8211FIELDAREA_H
#include "io/sio_8211FieldArea.h"
#endif

#ifndef INCLUDED_SIO_8211LEADER_H
#include "io/sio_8211Leader.h"
#endif

class sio_8211Record;
istream& operator>>(istream& istr, sio_8211Record& record);
ostream& operator<<(ostream& ostr, sio_8211Record const& record);


class sio_8211Record
{
   // Abstract class. Represents the commonality between a DDR and a DR.

   public:

      sio_8211Record();
      virtual ~sio_8211Record();

      // An 8211 Record has a leader, a directory and a field area.

      sio_8211Leader const* getLeader() const;
 
      sio_8211Directory const* getDirectory() const;

      sio_8211FieldArea const& getFieldArea() const;

      friend istream& operator>>(istream& istr, sio_8211Record& record);
      friend ostream& operator<<(ostream& ostr, sio_8211Record const& record);

   protected:

      sio_8211Leader* _leader;
      sio_8211Directory* _dir;
      sio_8211FieldArea _fieldArea;

      virtual istream& streamExtract(istream& istr) = 0;
      virtual ostream& streamInsert(ostream& ostr) const = 0;

};
/*
istream&
operator>>(istream& istr, sio_8211Record& record);

ostream&
operator<<(ostream& ostr, sio_8211Record const& record);
*/
#endif  // INCLUDED_SIO_8211RECORD_H
